
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>android消息处理机制原理解析 / 憋错料</title>

    <meta name="description" content="android消息处理机制原理解析 在android开发过程中相信屌丝程序员们都用过Handler来处理一些逻辑任务,比如发送延迟消息处理业务等逻辑,我们常用的图片加载缓存库ImageLoader和Picasso等内部也是通过Handler来最终有后台加载线程切换到主线程(UI线程)来更新页面的,今天就趁着离职有点儿时间就抽空的分析了下它的一点源码,在此总结出来.闲言少叙,书归正传! 先来谈谈Looper: Looper从源码上来看就是一个普通的Java类,它在消息机制中,顾名思义,就是一个消息循环的角色.有时候读源码,我习惯性的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">android消息处理机制原理解析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在android开发过程中相信屌丝程序员们都用过Handler来处理一些逻辑任务，比如发送延迟消息处理业务等逻辑，我们常用的图片加载缓存库ImageLoader和Picasso等内部也是通过Handler来最终有后台加载线程切换到主线程（UI线程）来更新页面的，今天就趁着离职有点儿时间就抽空的分析了下它的一点源码，在此总结出来。闲言少叙，书归正传！</p>
<h2>先来谈谈Looper:</h2>
<p>Looper从源码上来看就是一个普通的Java类，它在消息机制中，顾名思义，就是一个消息循环的角色。有时候读源码，我习惯性的会从它的构造器开始读，当然有时候会从一个方法切入，根据情况不同采取不同的方式。下面让我们看看Looper的构造器都做了什么:</p>
<pre><code>//(每个Looper对象的)消息队列，也就是说每个Looper对象都持有自己的消息队列
 final MessageQueue mQueue;
//(每个Looper线程关联的)当前线程
final Thread mThread;
private Looper(boolean quitAllowed) {
        //初始化当前Looper对象的消息队列
        mQueue = new MessageQueue(quitAllowed);
        mThread = Thread.currentThread();//获取当前线程
    }   </code></pre>
<p>从上面的代码中我们可以得出如下简单的结论：</p>
<p>a. 每个Looper对象都有自己的消息队列MessageQueue!</p>
<p>b. 每个Looper对象都和当前线程或者说创建Looper的线程相关联。</p>
<p>那么问题来了，当前线程是如何跟Looper对象想关联的呢？如果你读过Looper源码，从代码注释中你可以看到下面一个代码：</p>
<pre><code>  class LooperThread extends Thread {
        public Handler mHandler;
        public void run() {
            //注意是在run方法中调用了prepare
            Looper.prepare();
            mHandler = new Handler() {
                public void handleMessage(Message msg) {
                }
            };
            Looper.loop();
        }
    }</code></pre>
<p>可以发现里面调用了prepare()这个静态方法，所以直接看看prepare()这个方法做了什么了不起的事儿！</p>
<pre><code>//注意为静态final变量
static final ThreadLocal&lt;Looper&gt; sThreadLocal = new ThreadLocal&lt;Looper&gt;();
 public static void prepare() {
        prepare(true);
    }
    private static void prepare(boolean quitAllowed) {
        //一个Thread只能关联一个Looper对象
        if (sThreadLocal.get() != null) {
            throw new RuntimeException("Only one Looper may be created per thread");
        }
        sThreadLocal.set(new Looper(quitAllowed));
    }</code></pre>
<p>从代码上不难看出prepare做了两个工作：</p>
<p>a.在当前线程中创建一个Looper对象，放入ThreadLocal中；ThreadLocal作用简单来说就是在每个线程中存储数据，每个线程只能获取到自己存储在ThreadLocal的数据，其他的线程是获取不到自己线程存储在ThreadLocal的数据的。当然既然用ThreadLocal保存一个Looper那么我们肯定可以通过ThreadLocal得到这个Looper对象，方法如下：</p>
<pre><code>//获取当前线程关联的Looper对象
public static @Nullable Looper myLooper() {
        return sThreadLocal.get();
    }</code></pre>
<p>b.如果当前的线程已经有一个Looper对象相关联，就会抛出异常，也就是说一个Thread只能关联一个Looper对象</p>
<p>总之一句话prepare（）方法就是让线程关联Looper对象用的！</p>
<p>写到此处不难发现Looper已经完成了如下工作：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA4MTkxNjIxMTA1MTQ=.jpg"></p>
<p>这样我们线程也绑定Looper了，消息队列也由Looper对象创建好了，所以该是消息队列工作的时候了！！！那怎么才能让一个Looper对象持有的消息队列工作呢？其实笼统的说一句无非就是不停的从消息队列中查看是否有新的消息，有则处理，无则阻塞！这个处理消息的方法其实在上面的例子中也现身过，那就是loop()这个静态方法！</p>
<pre><code>  /**该方法必须在prepare方法之后调用**/
  public static void loop() {
        //获取当前线程锁关联的Looper对象
        final Looper me = myLooper();
        if (me == null) {//在调用loop()之前必须调用looper.prepare()方法
            throw new RuntimeException("No Looper; Looper.prepare() wasn‘t called on this thread.");
        }
        //获取当前对象的消息队列
        final MessageQueue queue = me.mQueue;

        ..........省略两行代码......
        for (;;) {//是一个无限循环，来遍历消息队列
            //获取一条消息Message对象，可能会造成阻塞，
            Message msg = queue.next(); // might block
            if (msg == null) {
                return;
            }

            //该消息的target是一个Handler,来分发消息，具体怎么分发稍后讨论
            msg.target.dispatchMessage(msg);

           .....省略部分代码..

            msg.recycleUnchecked();
        }
    }</code></pre>
<p>可以发现loop()方法其实执行了如下两步工作：</p>
<p>1）获取当前线程关联的Looper对象</p>
<p>2）获取Looper对象的消息队列然后开启无限循环获取消息和处理消息</p>
<p>重点就是第二步了，在无限循环中有且只有一个跳出的入口：那就是消息队列的next方法返回了null!另外需要注意的是next方法是一个阻塞方法，这也意味着当MessQueue没有消息的时候，next方法会阻塞进而使得loop方法也一直阻塞。当然next方法有新的消息的时候就调用  msg.target.dispatchMessage(msg);发送并处理消息！需要注意的消息队列中的Mssage都有自己的target对象来处理，target对象不唯一！。简单的概况下可以用如下流程图简单表示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA4MTkxNzI1MzY1ODk=.jpg"></p>
<p>通过上面的流程图也可以清晰的知道在获取到一个Messge对象之后，通过Message.target.dispatchMessage进行消息的分发和处理。那么这个target到底值什么鬼呢？还记得上文的例子代码LooperThread么？里面有个handler是什么意思呢会不会就这这个target呢？其实回答这个问题之前或许我们应该考虑：“我们是什么时候向Looper中的消息队列添加一条条消息来供loop循环读取呢？“</p>
<p>这就不得不说本篇博文的另一个主角Handler了，顺便说一句，Message的target你应该能想到其实也是一个Handler对象，不信？后面又说明！</p>
<h2>Handler简析</h2>
<p>先看看Handler的一个构造器，为了说明问题捡了其中的一个构造函数来说明：</p>
<pre><code>//当前线程关联Looper对象的消息队列
 final MessageQueue mQueue;
 //当前线程关联的Looper对象
  final Looper mLooper;
    public Handler(Callback callback, boolean async) {
        ...省略部分代码..
        //获取当前线程中关联的的Looper对象
        mLooper = Looper.myLooper();
        if (mLooper == null) {/不能在Thread里面创建Hanlder对象，如果没有调用prepare的话)
            throw new RuntimeException(
                "Can‘t create handler inside thread that has not called Looper.prepare()");
        }
        //这个就是初始化关联对象的地方
        mQueue = mLooper.mQueue;
        mCallback = callback;
        mAsynchronous = async;
    }</code></pre>
<p>从上面的代码中可以看出一个Handler对象有如下信息：</p>
<p>1）Handler对象持有一个Looper对象的引用mLooper 。</p>
<p>2）Handler对象持有一个消息队列对象的引用mQueue ，并且该引用在构造器中得到了初始化，初始化也很简单就是把looper对象创建的消息队列MessageQueue赋值给mQueue对象。</p>
<p>也就是说Handler关联了Looper对象及Looper对象创建的消息队列！</p>
<p>3）在一个子线程里面是如果没有调用Looper.prepare，不能创建Handler对象！</p>
<p>万事俱备，是时候回答“什么时候向消息队列添加消息”这个问题了！</p>
<p>在使用Handler的时候我们是通过sendMessage方法发送消息的，看看这个方法都做了什么，查看其源码，它的调用脉络是：</p>
<p>sendMessage(Message)–&gt;sendMessageDelayed(Message, long)–&gt;sendMessageAtTime(Message,long);所以直接看sendMessageAtTime这个方法即可：</p>
<pre><code>public boolean sendMessageAtTime(Message msg, long uptimeMillis) {
        MessageQueue queue = mQueue;
        ****省略了部分代码**
        return enqueueMessage(queue, msg, uptimeMillis);
    }
private boolean enqueueMessage(MessageQueue queue, Message msg, long uptimeMillis) {
        //初始化了target从这里可以看出来target就是一个Handler
        msg.target = this;
       //调用messageQueue的enqueueMessage插入消息
        return queue.enqueueMessage(msg, uptimeMillis);
    }</code></pre>
<p>最终sendMessageAtTime回调用enqueueMessage这个方法，这个方法可以得到如下结论：</p>
<p>a,上图中loop()循环取的message对象后调用message.target，这个target就是一个Handler！</p>
<p>b.Handler调用sendMessage方法发送消息的过程其实就是向MessageQueue这个消息队列插入一条消息的过程，另外我们到这里可以做出以下断言：在UI线程中（主线程）中创建的Handler对象通过sendMessage发送的Message实际上是添加到了UI线程的消息队列中！Looper的loop()方法通过循环消息队列，通过其next方法获取消息，然后处理之。所以下面就该讨论处理流程了。</p>
<p>很简单就从上图中的dispatchMessage方法说起：</p>
<pre><code> public void dispatchMessage(Message msg) {
        //如果创建的msg，设置了callback这个Runnable
        if (msg.callback != null) {
            //执行callback方法，其实是执行run方法
            handleCallback(msg);
        } else {//如果创建Handler的时候创建了Callback对象
            if (mCallback != null) {
                //执行callback的handleMessage方法
                if (mCallback.handleMessage(msg)) {
                    return;
                }
            }
            //让handler自己来处理msg
            handleMessage(msg);
        }
    }

 private static void handleCallback(Message message) {
        //只是简单的调用了Runnable的run方法
        message.callback.run();
    }
 //简单的接口，提供了一个handleMessage方法来处理消息
 public interface Callback {
        //返回一个boolean值
        public boolean handleMessage(Message msg);
    }</code></pre>
<p>所以Handler处理消息的过程其实也很简单：</p>
<p>a.检测Message的callback！=null,注意这个callback其实是一个Runnable，调用handleCallback方法其实就是执行这个Runnable的run方法而已。</p>
<p>b.如果创建Handler的时候，初始化了mCallack（这个callback并不是一个Ruannable，其实一个接口，该接口也很简单，就提供了一个handleMessage方法，由客户端决定怎么处理这条Message。</p>
<p>c.最后一步就是调用Handler的handleMessage方法来处理消息了。</p>
<p>通常我自己在使用Handler的时候就是用的定义一个Handler的子类，重写handleMessage方法来处理消息，倒是没有为Handler创建callback！</p>
<p>同时如果你设置了Handler的Callback，并且Callback的handleMessage方法如果返回true，那么Handler的handleMessage方法将不会执行；否则Handler的handleMessage方法也会得到执行！</p>
<p>所以通过上面的讲解，综合起来能得到下面的流程图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA4MTkyMTQ2MjIxMjc=.jpg"></p>
<p>到此位置android的消息机制可以说是解说完毕，不过还有些问题值得思考：我们说了这么多，那么android主线程（UI线程）的工作机制又是怎么样的呢？</p>
<h2>UI线程的消息处理</h2>
<p>在任何关于activity启动流程解析的资料中我们都会进入ActivityThread的main方法，这里当然不会再分析Activity的启动流程，拿来主义有时候还是不错的（需要注意一点ActivityThread不是一个Thread，只是一个普通的java对象：</p>
<pre><code> public static void main(String[] args) {
        //创建主线程的Looper对象，prepareMainLooper内部实际上调用了
        //Looper.prepare(false)方法，并把UI线程交给Looper的静态变量             //Looper sMainLooper;持有
        Looper.prepareMainLooper();
        //创建ActivityThread对象
        ActivityThread thread = new ActivityThread();
        thread.attach(false);
        //创建一个Handler，这个Handler就是关联了UI消息队列的Handler
        if (sMainThreadHandler == null) {
            sMainThreadHandler = thread.getHandler();
        }
        //开启了消息循环
        Looper.loop();
    }
}</code></pre>
<p>结合前面关于Looper的分析，其实ActivityThread的main方法也很简单，其流程如下：</p>
<p>1）调用Looper.prepareMainLooper()使得UI线程也就是主线程与一个Looper对象想关联。prepareMainLooper方法如下：</p>
<pre><code> //提供一个静态变量来持有UI线程的Looper对象
 private static Looper sMainLooper;
  public static void prepareMainLooper() {
        //为UI线程创建一个Looper对象
        prepare(false);
        synchronized (Looper.class) {
            if (sMainLooper != null) {
                throw new IllegalStateException("The main Looper has already been prepared.");
            }
            //静态变量来引用这个关联了UI线程的Looper对象
            sMainLooper = myLooper();
        }
    }
</code></pre>
<p>既然Looper用一个静态变量来保存关联了UI线程的Looper对象，那么我们可以调用Looper的如下两个方法检测是否是主线程：</p>
<pre><code>//Picasso提供的检测是否是UI线程的方法
 static boolean isMain() {
    return Looper.getMainLooper().getThread() == Thread.currentThread();
  }</code></pre>
<p>而ImageLoader检测是否是UI线程的方法则是如下：</p>
<pre><code> Looper.myLooper() == Looper.getMainLooper()</code></pre>
<p>2）创建一个Handler对象，根据前面的讲解这个Handler对象同样关联了UI线程的looper对象以及该looper对象的消息队列</p>
<p>3）调用Looper.loop()循环获取和处理消息。</p>
<p>需要注意的是：根据Looper源码的注释，android官方并不希望我们自己主动调用prepareMainLooper()方法。</p>
<h2>最后的总结</h2>
<p>这样UI线程的处理流程也简单的梳理完毕，那么还有一个最后一个问题：我们知道UI组件的更新是是在UI线程中进行的，也即是如果你在非线程中处理了某个任务后需要更新UI组件,那么在非UI线程线程工作完成后都需要交给UI线程来处理，怎么通知UI线程呢？你应该会知道答案：通过Handler，在UI线程中创建Handler，在非UI线程工作完毕后调用UI线程创建的Handler发送消息到UI消息队列，然后按照上面的流程图处理即可。</p>
<p>前面我既然分析了ImageLoader的源码（详见<a href="http://blog.csdn.net/chunqiuwei/article/category/6318977" rel="external nofollow noreferrer">ImageLoader博客</a>），那么就根据ImageLoader的工作原理把非UI线程和UI线程的工作流程也做个总结吧，如下图所示：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA4MTkyMzAzMDM2NTU=.jpg"></p>
<p>到此为止android消息处理机制就简单的讲解完毕，如有不当的地方欢迎批评指正，共同学习！</p>
<p>其实多写博客还是有所帮助的，比如我在写这篇博客的时候，边分析Looper和Handler的源码，有的时候还需要ImageLoader的工作原理来配合加深理解和体会。如果我之前没有写过ImageLoader博客的话，理解或者体会或许就不那么深了，这也算是坚持写博客对自己的回报吧！</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-24 05:56:42 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>android消息处理机制原理解析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pWBeo3.html" rel="bookmark">Android 消息处理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.消息处理机制简介 主要用于进程内线程之间的通信,主线程一般调用looper()进行循环等待处理消息,其它线程向它发消息并指定消息的处理方法. (1)涉及文件包括frameworks中的:Looper.javaHandler.javaMessageQueue.javaMessage.javaandroid_os_MessageQueue.cpp...涉及文件包括system中的:Looper.hLooper.cpp (2)涉及native处理机制使用pipe加epoll机制实现消息队列的睡眠和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0doggZM.html" rel="bookmark">&lbrack;学习总结&rsqb;6、Android异步消息处理机制完全解析，带你从源码的角度彻底理解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				开始进入正题,我们都知道,Android UI是线程不安全的,如果在子线程中尝试进行UI操作,程序就有可能会崩溃.相信大家在日常的工作当中都会经常遇到这个问题,解决的方案应该也是早已烂熟于心,即创建一个Message对象,然后借助Handler发送出去,之后在Handler的handleMessage()方法中获得刚才发送的Message对象,然后在这里进行UI操作就不会再出现崩溃了. 这种处理方式被称为异步消息处理线程,虽然我相信大家都会用,可是你知道它背后的原理是什么样的吗?今天我们就来一起			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXZQNw3.html" rel="bookmark">Android消息处理机制（源码分析）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 虽然一直在做应用层开发,但是我们组是核心系统BSP,了解底层了解Android的运行机制还是很有必要的.就应用程序而言,Android系统中的Java应用程序和其他系统上相同,都是靠消息驱动来工作的,它们大致的工作原理如下: 1. 有一个消息队列,可以往这个消息队列中投递消息. 2. 有一个消息循环,不断从消息队列中取出消息,然后处理 . 为了更深入的理解Android的消息处理机制,这几天空闲时间,我结合&lt;深入理解Android系统&gt;看了Handler.Looper.Message这几			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXDpLzM.html" rel="bookmark">Android动画机制全解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				导论 本文着重讲解Android3.0后推出的属性动画框架Property Animation--Animator. 产生原因 3.0之前已有的动画框架--Animation存在一些局限性, Animation框架定义了透明度,旋转,缩放和位移几种常见的动画,而且控制的是整个View,实现原理是每次绘制视图时View所在的ViewGroup中的drawChild函数获取该View的Animation的Transformation值,然后调用canvas.concat(transformToApp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoXlRw0.html" rel="bookmark">Android消息处理机制：源码剖析Handler、Looper，并实现图片异步加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 我们在做 Android 开发时,常常需要实现异步加载图片/网页/其他.事实上,要实现异步加载,就需要实现线程间通信,而在 Android 中结合使用 Handler.Looper.Message 能够让不同的线程通信,完成异步任务.虽然 Android 官方为我们提供了 AsyncTask 类来完成异步任务,但这个类存在许多问题,并不好用,而且,AsyncTask 也是通过 Handler 和 Thread 来实现异步加载的,所以学习这方面的知识是有必要的 本文讲解思路大致如下:绘制 A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Apl9v3.html" rel="bookmark">Android消息处理机制</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章出处:http://www.cnblogs.com/qingblog/archive/2012/06/27/2566021.html Google参考了Windows的消息处理机制,在Android系统中实现了一套类似的消息处理机制.学习Android的消息处理机制,有几个概念(类)必须了解: 1.       Message 消息,理解为线程间通讯的数据单元.例如后台线程在处理数据完毕后需要更新UI,则可发送一条包含更新信息的Message给UI线程. 2.       Message Q			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lp78L0.html" rel="bookmark">android消息机制原理详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				android消息机制原理详解 因为之前使用的是CSDN默认的文本编辑器,而且也因为懒得学用MarkDown来写博客,所以排版上有一些问题.就上一篇写的设计模式之抽象工厂模式提出了这个问题(一个android群的群友提出来的,没有在评论里评论),所以以后的文章都用MarkDown来写了. 好了,言归正传,这篇文章我来介绍一下android消息机制的原理 Android消息机制概述 说到Android的消息机制,Android初级工程师(不包括那些初学者)肯定会想到Handler.是的,Andro			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0koP7j0.html" rel="bookmark">【Android 开发】&colon; Android 消息处理机制之一&colon; Handler 与 Message</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近几讲内容,我们学习了Android中关于多线程的一些知识,上一讲我们讲解了异步任务 AsyncTask 的操作,Android中还提供了其他的线程操作,如Handler Message MessageQueue Looper 等模块,这些就是Android中的消息处理机制.这部分内容是Android学习过程中的重点和难点.    现在我们就来学习一下Android的消息处理,以及剖析一下相关类如Handler和Message类的源代码,同时使用他们来更新UI主线程的操作.因为Android的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/471dyk0.html" rel="bookmark">Android -- 消息处理机制源码分析&lpar;Looper&comma;Handler&comma;Message&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				android的消息处理有三个核心类:Looper,Handler和Message.其实还有一个Message Queue(消息队列),但是MQ被封装到Looper里面了,我们不会直接与MQ打交道,因此我没将其作为核心类.下面一一介绍: Looper Looper的字面意思是“循环者”,它被设计用来使一个普通线程变成Looper线程.所谓Looper线程就是循环工作的线程.在程序开发中(尤其是GUI开发中),我们经常会需要一个线程不断循环,一旦有新任务则执行,执行完继续等待下一个任务,这就是Lo			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/n0lxxB0.html" rel="bookmark" class="title">Java重要技术&lpar;13&rpar;内省之属性描述符PropertyDescriptor</a>
					<div>
						1.1. 属性描述符(PropertyDescriptor) 可以使用PropertyDescrptor类来访问Java Bean的属性和方法. Object obj; Class beanClass ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r588g0.html" rel="bookmark" class="title">百度学术</a>
					<div>
						http://xueshu.baidu.com/?tn=SE_baiduxueshu_c1gjeupa 2014年6月初,“百度学术搜索”上线.百度学术搜索是百度旗下的提供海量中英文文献检索的学术资源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5eBb0.html" rel="bookmark" class="title">VB中 ByRef与ByVal区别</a>
					<div>
						函数调用的参数传递有&quot;值传递&quot;和&quot;引用传递&quot;两种传递方式.如果采用&quot;值传递&quot;,在函数内部改变了参数的值,主调程序的对应变量的值不会改变:如果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDLyBM.html" rel="bookmark" class="title">wifi display代码 分析</a>
					<div>
						转自:http://blog.csdn.net/lilian0118/article/details/23168531 这一章中我们来看Wifi Display连接过程的建立,包含P2P的部分和RTS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wyWr1M.html" rel="bookmark" class="title">浅议tomcat与classloader</a>
					<div>
						关于tomcat和classloader的文章,网上多如牛毛,且互相转载,所以大多数搜到的基本上是讲到了tomcat中classloader的几个层次,对于初接触classloader,看了之后还是只 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzvkP0.html" rel="bookmark" class="title">王家林最新介绍</a>
					<div>
						王家林老师(联系邮箱[email protected] 电话:18610086859 QQ:1740415547 微信号:18610086859) Spark亚太研究院院长和首席专家,中国目前唯一的移 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02kBqa3.html" rel="bookmark" class="title">zmq笔记二&colon; io线程和poller&lowbar;t</a>
					<div>
						int major, minor, patch;zmq_version(&amp;major, &amp;minor, &amp;patch); //4.2.0 本文主要是分析代码,方便自己日后查阅. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pzxqV0.html" rel="bookmark" class="title">缓冲区溢出攻击实验&lpar;另附源代码&rpar;</a>
					<div>
						缓冲区溢出攻击代码如下: #include&lt;Windows.h&gt; #include&lt;stdio.h&gt; #include&lt;string.h&gt; void f(char  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pQaKyM.html" rel="bookmark" class="title">linux 系统没有默认的目录</a>
					<div>
						[问题描述]首先在linux的Home目录下并没有找到 Pictures这个目录,于是先新建一个Pictures,但当使用快捷键 PrtScrn或Alt+Prtscrn或Shift+PrtScrn后并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGpmoV0.html" rel="bookmark" class="title">iOS算法&lpar;一&rpar;置快速排序算法</a>
					<div>
						快速排序是当遇到较大数据时,排序快,高效的方法(公司面试时,基本上会被问到...) 该方法的基本思想是: 1．先从数列中取出一个数作为基准数. 2．分区过程,将比这个数大的数全放到它的右边,小于或等于 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODGgr4.html" rel="bookmark" class="title">CISCO 5510 ASDM的实战总结</a>
					<div>
						环境:ASA5510 iSO: 8.2(5) win 7(64)英文旗舰版 远程到防火墙中输入ASDM的开启命令 ciscoasa&gt;ciscoasa&gt; enPassword:ciscoas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPwGj64.html" rel="bookmark" class="title">程序人生出口</a>
					<div>
						看到一篇文章,总结了下程序人生出口,感觉很不错,对于爱好技术的我蛮喜欢第一条的,其次是第二条,你的出口是哪条呢? 1.成就超一流高手 简单来讲就是继续以程序员的身份进行奋斗成为牛人. 2.积累.爆发. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0a1kaq0.html" rel="bookmark" class="title">object-c NSString 转成特定编码格式如utf8、gbk等</a>
					<div>
						有两种方式 第一种是先转换成特定编码格式NSDATA 第二种是先转换成特定编码格式char *(cString) 转成gbk: 第一种: - (NSString *) utf82gbk:(NSStri ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm9W6XM.html" rel="bookmark" class="title">PyQt挖地雷游戏学习笔记（6）</a>
					<div>
						学习别人的作品,有一大好处,可以反观自己的不足. 自己的不足,往往是基础知识有欠缺,基本功不扎实. 今天,再补一课:星号表达式(*expression). 挖地雷程序中,有2处用到星号表达式.一是在m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWqKzr3.html" rel="bookmark" class="title">hdu 4882 ZCC Loves Codefires &lpar;贪心 推导&rpar;</a>
					<div>
						题目链接 做题的时候凑的规律,其实可以 用式子推一下的. 题意:n对数,每对数有e,k, 按照题目的要求(可以看下面的Hint就明白了)求最小的值. 分析:假设现在总的是sum, 有两个e1 k1 e ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm9kaVM.html" rel="bookmark" class="title">HDFS NameNode内存详解</a>
					<div>
						前言 &lt;HDFS NameNode内存全景&gt;中,我们从NameNode内部数据结构的视角,对它的内存全景及几个关键数据结构进行了简单解读,并结合实际场景介绍了NameNode可能遇到的问题 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ez6kJ3.html" rel="bookmark" class="title">多线程的创建、退出、等待、删除语法</a>
					<div>
						1.多线程创建pthread_create()的语法 2.多线程退出pthread_exit()的语法 3.多线程等待pthread_join()的语法 4.多线程删除pthread_cancel() ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4J9BZb3.html" rel="bookmark" class="title">iOS 自动布局和弹性盒子</a>
					<div>
						当同事问到我这个问题时,我脑子中直接冒出了一个词&quot;弹性盒子&quot;. 问题: 有一个 Cell 中有 4 个并排排列的控件,布局如下图所示: 假设: 1.        这些控件高度和y ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmNWXX0.html" rel="bookmark" class="title">小红帽5&period;9 配置静态IP上网问题</a>
					<div>
						本来无一物,何处染尘埃. DHCP连得好好的,手痒试下STATIC,静态IP 首先进入/etc/sysconfig/network-scripts/ifcfg-eth0, 写入各种参数: BOOTPR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bKZrm3.html" rel="bookmark" class="title">CSS3 Transitions</a>
					<div>
						  CSS3 transitions allows you to change property values smoothly (from one value to another), over a ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
